teveoapp/teveoproject/teveoapp/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path("", views.index, name="index"),
    path("camaras/", views.camaras, name="camaras"),
    path("camara/<str:id>/", views.camara, name="camara"),
    path("camaradyn/<str:id>/", views.camaradyn, name="camaradyn"),
    path('comentario/<str:id>/', views.comentario, name='comentario'),
    path("image_embedded/<str:camara_id>/", views.image_embedded, name="image_embedded"),
    path('comment_embedded/<str:camara_id>/', views.comment_embedded, name='comment_embedded'),
    path("json/<str:id>/", views.json, name="json"),
    path("configuracion/", views.configuracion, name="configuracion"),
    path("ayuda/", views.ayuda, name="ayuda"),
    path("salir/", views.salir, name="salir"),
]

teveoapp/teveoproject/teveoproject/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("teveoapp.urls"))
]

teveoapp/teveoproject/teveoapp/models.py
from django.db import models
from django.db.models import Count


class Usuario(models.Model):
    """
    Base de datos usada para guardar información acerca del nombre del visitante, tamaño y tipo de letra
    """
    id = models.CharField(max_length=80, primary_key=True)
    nombre = models.CharField(max_length=64, default="Anonimo")

    FORMATO = [
        ('Calibri', 'Calibri'),
        ('Times-New-Roman', 'Times New Roman'),
        ('Courier-New', 'Courier New'),
        ('Cursive', 'Cursive')
    ]
    formato = models.CharField(max_length=64, choices=FORMATO, default='Calibri')

    TIPO = [
        ('Large', 'Grande'),
        ('Medium', 'Mediana'),
        ('Small', 'Pequeña')
    ]
    tipo = models.CharField(max_length=64, choices=TIPO, default='Medium')


class Camara(models.Model):
    """
    Base de datos encargada de guardar la información sobre una cámara
    """
    id = models.CharField(max_length=80, primary_key=True)
    ubicacion = models.CharField(max_length=64)
    longitud = models.CharField(max_length=64)
    latitud = models.CharField(max_length=64)
    fuente = models.URLField()

    @staticmethod
    def get_ordered_by_num_comments():
        return Camara.objects.annotate(num_comentarios=Count('comentario')).order_by('-num_comentarios')


class Comentario(models.Model):
    """
    Base de datos encargada de guardar la información sobre un comentario, asociado a una cámara
    """
    camara = models.ForeignKey(Camara, on_delete=models.CASCADE)
    autor_nombre = models.CharField(max_length=64)
    texto = models.TextField(blank=False)
    fecha = models.DateTimeField()
    imagen = models.TextField(null=True, blank=True)  # Imagen en formato base64

    @staticmethod
    def get_ordered_comments():
        return Comentario.objects.order_by("-fecha")

teveoapp/teveoproject/teveoapp/views.py
from django.shortcuts import render, redirect, get_object_or_404
from .models import Usuario, Camara, Comentario
from django.http import HttpResponse
import urllib.request
from .listado1 import Listado1xmlParser
from .listado2 import Listado2xmlParser
import random
from django.utils import timezone
import base64
from django.http import JsonResponse, HttpResponseNotFound

# Create your views here.

# source django-venv/bin/activate
# python3 manage.py makemigrations
# python3 manage.py migrate
# python3 manage.py createsuperuser
# python3 manage.py runserver 8080
# ./manage.py test


def index(request):
    """
    Manejador de página principal
    """
    if not request.session.session_key:
        request.session.create()

    session_key = request.session.session_key
    configuracion, created = Usuario.objects.get_or_create(
        id=session_key,
        defaults={'nombre': 'Anonimo', 'formato': 'Calibri', 'tipo': 'Medium'}
    )

    camaras = Camara.objects.all()

    comentarios = Comentario.get_ordered_comments()

    n_camaras = Camara.get_ordered_by_num_comments().count()
    n_coments = comentarios.count()

    context = {
        "camaras": camaras,  # Todas las cámaras
        "comentarios": comentarios,  # Todos los comentarios ordenados por fecha descendente
        "n_camaras": n_camaras,
        "n_coments": n_coments,
        "usuario": configuracion
    }

    return render(request, "teveoapp/index.html", context)


def obtener_lista1():
    url = "https://gitlab.eif.urjc.es/cursosweb/2023-2024/final-teveo/-/raw/main/listado1.xml"
    xml = urllib.request.urlopen(url)
    Listado1xmlParser(xml)


def obtener_lista2():
    url = "https://gitlab.eif.urjc.es/cursosweb/2023-2024/final-teveo/-/raw/main/listado2.xml"
    xml = urllib.request.urlopen(url)
    Listado2xmlParser(xml)


def camaras(request):
    """
    Manejador de vista camaras
    """
    if not request.session.session_key:
        request.session.create()

    session_key = request.session.session_key
    configuracion, created = Usuario.objects.get_or_create(
        id=session_key,
        defaults={'nombre': 'Anonimo', 'formato': 'Calibri', 'tipo': 'Medium'}
    )

    if request.method == "POST":
        if "lista1" in request.POST:
            obtener_lista1()
        elif "lista2" in request.POST:
            obtener_lista2()
        return redirect("/camaras/")

    elif request.method == "GET":
        camaras = Camara.objects.all()
        camaras_ordenadas = Camara.get_ordered_by_num_comments()
        comentarios = Comentario.get_ordered_comments()
        n_camaras = Camara.get_ordered_by_num_comments().count()
        n_coments = comentarios.count()

        imagen_random = random.choice(camaras) if camaras else None

        context = {
            "camaras": camaras_ordenadas,
            "n_camaras": n_camaras,
            "n_coments": n_coments,
            "imagen_random": imagen_random,
            "configuracion": configuracion,
            "usuario": configuracion
        }
        return render(request, "teveoapp/camaras.html", context)


def obtener_datos_camara(request, id):
    """
    Función auxiliar para obtener los datos de una cámara.
    """
    if not request.session.session_key:
        return None, None, None, None, None

    session_key = request.session.session_key
    configuracion, created = Usuario.objects.get_or_create(
        id=session_key,
        defaults={'nombre': 'Anonimo', 'formato': 'Calibri', 'tipo': 'Medium'}
    )

    try:
        comentarios = Comentario.get_ordered_comments()

        n_camaras = Camara.get_ordered_by_num_comments().count()
        n_coments = comentarios.count()

        camara = Camara.objects.get(id=id)
        comentarios = Comentario.get_ordered_comments().filter(camara=camara)
        return n_camaras, n_coments, camara, comentarios, configuracion
    except Camara.DoesNotExist:
        return None, None, None, None, None


def camara(request, id):
    """
    Manejador de vista de una cámara
    """
    if request.method == "GET":
        if not request.session.session_key:
            request.session.create()

        n_camaras, n_coments, camara, comentarios, configuracion = obtener_datos_camara(request, id)
        if camara:
            return render(request, "teveoapp/camara.html", {
                "camara": camara,
                "comentarios": comentarios,
                "n_camaras": n_camaras,
                "n_coments": n_coments,
                "configuracion": configuracion,
                "usuario": configuracion
            })
        else:
            return HttpResponse("Error, no existe la cámara que busca", status=404)


def camaradyn(request, id):
    """
    Manejador de vista de una cámara dinámica
    """
    if request.method == "GET":
        if not request.session.session_key:
            request.session.create()

        n_camaras, n_coments, camara, comentarios, configuracion = obtener_datos_camara(request, id)
        if camara:
            return render(request, "teveoapp/camaradyn.html", {
                "camara": camara,
                "comentarios": comentarios,
                "n_camaras": n_camaras,
                "n_coments": n_coments,
                "configuracion": configuracion,
                "usuario": configuracion
            })
        else:
            return HttpResponse("Error, no existe la cámara que busca", status=404)


def capturar_imagen_de_camara(camara):  # Para guardar la imagen con el comentario
    try:
        # Descargar la imagen de la cámara en la que se va a comentar
        image = descargar_imagen(camara.id)
        if image is not None:
            # Convertir la imagen a base64
            image_base64 = base64.b64encode(image).decode('utf-8')
            return image_base64
    except Exception as e:
        print(f"Error al capturar imagen de la cámara: {e}")
    return None


def comentario(request, id):

    session_key = request.session.session_key
    configuracion = Usuario.objects.filter(id=session_key).first()

    camara = get_object_or_404(Camara, id=id)
    comentarios = Comentario.get_ordered_comments()

    n_camaras = Camara.get_ordered_by_num_comments().count()
    n_coments = comentarios.count()

    fecha = timezone.now()

    if request.method == "POST":
        coment = request.POST.get('texto')
        if coment:
            img = capturar_imagen_de_camara(camara)
            comentario = Comentario(
                camara=camara,
                autor_nombre=configuracion.nombre,
                texto=coment,
                fecha=timezone.now(),
                imagen=img
            )
            comentario.save()
            return redirect(f'/camara/{id}/')
        else:
            return HttpResponse("Error, por favor introduce un comentario.", status=400)

    context = {
        'n_camaras': n_camaras,
        'n_coments': n_coments,
        'usuario': configuracion,
        'id': id,
        'camara': camara,
        'fecha': fecha
    }
    return render(request, 'teveoapp/comentario.html', context)


# Indica que la solicitud proviene de un navegador Firefox
headers = {
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:100.0) Gecko/20100101 Firefox/100.0'
}


def descargar_imagen(ident):
    """
    Descarga imagen desde una URL y la devuelve en forma de bytes
    """
    try:
        # Obtiene la instancia de Camara con el ID proporcionado en ident
        camara = Camara.objects.get(id=ident)
        # Obtiene la URL de la fuente de la cámara
        url_cam = camara.fuente
        # print(f"Descargando imagen desde {url_cam}") # -> error 403 en PythonAnyWhere
        # Define los parámetros para la solicitud HTTP
        request = urllib.request.Request(url=url_cam, headers=headers)
        # Abre la conexión y realiza la solicitud HTTP
        with urllib.request.urlopen(request) as response:
            # Leer la respuesta HTTP y guardarla como imagen en bytes
            image = response.read()
            # Devuelve la imagen descargada
            return image
            # print("Imagen descargada con éxito")

    # Captura la excepción si no se encuentra la Camara
    except Camara.DoesNotExist:
        print("No existe la cámara")
        return None

    # Captura la excepción si hay un error al realizar la solicitud HTTP
    except urllib.error.URLError:
        # print(f"Error al descargar la imagen: {e}")
        return None


def imagen():
    """
    Devuelve imagen descargada como una respuesta HTTP
    """
    # Obtener imagen en bytes
    image = descargar_imagen(id)
    if image is None:
        return HttpResponse("Error al descargar la imagen", status=500)
    else:
        # Respuesta HTTP con la imagen
        return HttpResponse(image, content_type="image/jpeg")


def image_embedded(request, camara_id):
    """
    Maneja la solicitud web y devuelve una respuesta HTML que contiene una imagen
    incrustada directamente en el HTML utilizando codificación en Base 64
    """
    # Llama a la función descargar_imagen() para obtener la imagen en bytes
    image = descargar_imagen(camara_id)

    if image is None:
        # Si no se pudo descargar la imagen, error con código 500
        return HttpResponse("Error al descargar la imagen", status=500)
    else:
        # Codifica la imagen en base64 para ser incrustada en el HTML
        image_base64 = base64.b64encode(image).decode('utf-8')

        # Crea el fragmento de HTML que incrusta la imagen en formato base64
        html = f'<img src="data:image/jpeg;base64,{image_base64}">'

        # Retorna una respuesta HTTP con el HTML que contiene la imagen incrustada
        return HttpResponse(html, content_type="text/html")


def comment_embedded(request, camara_id):
    # Obtener el objeto Camara dado su id (camara_id) o error 404 not found
    camara = get_object_or_404(Camara, id=camara_id)

    # Obtener todos los comentarios ORDENADOS para la cámara

teveoapp/teveoproject/teveoapp/templates/teveoapp/ayuda.html
{% extends 'teveoapp/base.html' %}
{% block contenido %}
    {% if usuario %}
    <h1><strong>Bienvenidos a TeVeO APP</strong></h1>
    <ul>
        <h3><strong>DATOS DEL AUTOR</strong></h3>
        <p><strong>Nombre:</strong> Jorge Rincón Moráis.</p>
        <p><strong>Grado:</strong> Ingeniería en Sistemas de Telecomunicación y ADE.</p>
        <p><strong>Asignatura:</strong> Servicios y Aplicaciones en Redes de Ordenadores (SARO).</p>
    </ul>
    <p></p>
    <ul>
        <h3><strong>EXPLICACIÓN DE LA PRÁCTICA</strong></h3>
        <p><strong>Página Principal:</strong> Incluye todos los comentarios que se han incluido en las cámaras con el
            nombre de la cámara, el ID de la cámara, el nombre del comentador, la fecha y el texto del comentario.</p>
        <p><strong>Página de Cámaras:</strong> Incluye la imagen aleatoria de una de las fuentes disponibles, la opción
            de descargar los listados de cámaras y la lista con las camaras activas, cada una con su información.</p>
        <p><strong>Página de Configuración:</strong> Permite cambiar el nombre del comentador, formato de la letra de
            la página y el tamaño de la letra según las necesidades del cliente.</p>
        <p><strong>Página de Ayuda:</strong> Incluye la información del autor de la práctica, junto con una breve
            explicación de la misma.</p>
        <p><strong>Página de Admin:</strong> Permite administrar los datos de la base de datos de la aplicación en
            Django.</p>
    </ul>

    <ul>
        <h3><strong>Contraseña del Admin site de Django</strong></h3>
        <p><strong>Usuario: </strong>admin</p>
        <p><strong>Contraseña: </strong>admin</p>
    </ul>

    <p></p>
    <div id="carouselExample" class="carousel slide">
      <div class="carousel-inner">
        <div class="carousel-item active">
          <img src="https://www.telemadrid.es/2018/10/03/noticias/madrid/Universidad-Rey-Juan-Carlos-recurrira_2054804545_6508508_1300x731.jpg" class="d-block w-100" alt="Logo URJC">
        </div>
        <div class="carousel-item">
          <img src="https://scrabblemania.es/image-of-word-from-letters/Saro" class="d-block w-100" alt="Asignatura SARO">
        </div>
        <div class="carousel-item">
          <img src="https://miro.medium.com/v2/resize:fit:883/1*ak_Q0_hlOlz-5qjA7hDktg.jpeg" class="d-block w-100" alt="PYTHON, HTML Y CSS">
        </div>
      </div>
      <button class="carousel-control-prev" type="button" data-bs-target="#carouselExample" data-bs-slide="prev">
        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
        <span class="visually-hidden">Previous</span>
      </button>
      <button class="carousel-control-next" type="button" data-bs-target="#carouselExample" data-bs-slide="next">
        <span class="carousel-control-next-icon" aria-hidden="true"></span>
        <span class="visually-hidden">Next</span>
      </button>
    </div>

    {% else %}
        <p>Falta configuración.</p>
    {% endif %}
{% endblock %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/base.html
<!DOCTYPE html>
<html lang="es">
{% load static %}
<head>
    <!-- Required meta tags -->
    <meta charset="UTF-8">
    <!-- HTMX -->
    <script src="https://unpkg.com/htmx.org@1.9.10"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- BOOTSTRAP -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">
    <!-- CSS -->
    <link href="{% static 'teveoapp/style.css' %}" rel="stylesheet">
    <!-- favicon.ico -->
    <link rel="icon" type="image/x-icon" href="{% static 'teveoapp/favicon.ico' %}">
    <title>TeVeO</title>
</head>

<body class="{{ usuario.tipo }} {{ usuario.formato }}">
    <header>
        <h1><a href="/">TeVeO APP</a></h1>
        <h2 id="username">Usuario: {{ usuario.nombre }}</h2>
    </header>

    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                <li class="nav-item">
                    <a class="nav-link active" href="/">Principal</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" href="/camaras/">Cámaras</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" href="/configuracion/">Configuración</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" href="/ayuda/">Ayuda</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" href="/admin">Admin</a>
                </li>
            </ul>
        </div>
    </nav>

    <div class="container main-container mt-5">
        <div class="row">
            <div class="col-md-12">
                {% block contenido %}
                {% endblock %}
            </div>
        </div>
    </div>

    <footer>
        <div class="container py-4 stats-box">
            <h4 class="text-center">Resumen:</h4>
            <hr>
            <div class="row justify-content-center">
                <div class="col-md-6">
                    <p><strong>Total de Cámaras:</strong> {{ n_camaras }}</p>
                    <p><strong>Total de Comentarios:</strong> {{ n_coments }}</p>
                </div>
            </div>
        </div>
    </footer>

    <!-- Opción 1: BOOTSTRAP JS bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>
</body>
</html>

teveoapp/teveoproject/teveoapp/templates/teveoapp/camara.html
{% extends "teveoapp/base.html" %}

{% block contenido %}
<div>
    <h3>INFORMACIÓN DE LA CÁMARA:</h3>
    <p>Nombre de la cámara: {{ camara.ubicacion }}</p>
    <p>Coordenadas:</p>
    <p>- Latitud: {{ camara.latitud }}</p>
    <p>- Longitud: {{ camara.longitud }}</p>
    <p>Para comentar sobre esta imagen: <a href="{% url 'comentario' camara.id %}">Pulse aquí</a></p>
    <p>Página dinámica: <a href="{% url 'camaradyn' camara.id %}">Pulse aquí</a></p>
    <img src="{{ camara.fuente }}" alt="Imagen de la cámara">
</div>

{% if comentarios %}
    <h3>Comentarios de la cámara:</h3>
    {% for coment in comentarios %}
        <li class="comment">
            <div class="comment-box">
                <div class="comment-info">
                    <p><strong>Cámara:</strong> {{ coment.camara.id }}</p>
                    <p><strong>Autor:</strong> {{ coment.autor_nombre }}</p>
                    <p><strong>Fecha:</strong> {{ coment.fecha }}</p>
                    <p><strong>Comentario:</strong></p>
                    <div class="comment-text">
                        {{ coment.texto }}
                    </div>
                </div>
                {% if coment.imagen %}
                    <div class="comment-image">
                        <img class="comment-img" src="data:image/jpeg;base64,{{ coment.imagen }}" alt="Imagen de comentario">
                    </div>
                {% endif %}
            </div>
        </li>
    {% endfor %}
{% else %}
    <p>No hay comentarios para esta cámara. ¡Sé el primero en comentar!</p>
{% endif %}

{% endblock %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/camaradyn.html
{% extends "teveoapp/base.html" %}
{% block contenido %}

<head>
    <script src='https://unpkg.com/htmx.org@1.9.10'></script>
</head>
<div class="row">
    <div class="col mb-4">
        <ul>
            <li>
                <h3>INFORMACIÓN DE LA CÁMARA:</h3>
                <p>Nombre: {{ camara.ubicacion }}</p>
                <p>Coordenadas: </p>
                <p>- Latitud: {{ camara.latitud }}</p>
                <p>- Longitud: {{ camara.longitud }}</p>
                <p>Para poner comentarios: <a href="{% url 'comentario' camara.id %}">Pulse aquí</a></p>
                <p>Para acceder a la página de la cámara: <a href="{% url 'camara' id=camara.id %}">Pulse aquí</a></p>
            </li>
        </ul>
        <div class="mb-4">
            <!--
             hx-get: URL a la cual HTMX realizará una solicitud GET
             hx-trigger: load es que se realiza cuando la página se cargue cada 30 seg
             hx-swap: cómo se actualizará el contenido, innerHTML indica que el contenido HTML devuelto por la solicitud se insertará dentro del elemento <div> que contiene el atributo hx-get.
             -->
            <div hx-get="{% url 'image_embedded' camara.id %}"
                 hx-trigger="load, every 30s"
                 hx-swap="innerHTML">
            </div>
        </div>
        <div id="comentarios" hx-get="{% url 'comment_embedded' camara.id %}"
             hx-trigger="load, every 30s"
             hx-swap="innerHTML">
            {% include "teveoapp/comentariosdyn.html" %}
        </div>
    </div>
</div>

{% endblock %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/camaras.html
{% extends "teveoapp/base.html" %}

{% block contenido %}

<div class="container">
    <!-- Imagen Aleatoria -->
    {% if imagen_random %}
    <div>
        <h2>Imagen aleatoria: </h2>
        <a href="/camara/{{ imagen_random.id }}">
            <img src="{{ imagen_random.fuente }}" alt="Imagen aleatoria de la cámara {{ imagen_random.name }}" class="img-fluid random-image">
        </a>
    </div>
    {% endif %}

    <!-- Lista 1 -->
    <div class="mt-4">
        <form action="" method="POST">
            {% csrf_token %}
            <p>Descargar lista 1: <button type="submit" class="btn btn-primary">Descargar</button></p>
            <!-- Campo oculto para indicar la solicitud de descarga de lista 1 -->
            <input type="hidden" name="lista1" value="lista1">
        </form>
    </div>

    <!-- Lista 2 -->
    <div>
        <form action="" method="POST">
            {% csrf_token %}
            <p>Descargar lista 2: <button type="submit" class="btn btn-primary">Descargar</button></p>
            <!-- Campo oculto para indicar la solicitud de descarga de lista 2 -->
            <input type="hidden" name="lista2" value="lista2">
        </form>
    </div>

    <div class="mt-4">
        {% if camaras %}
            <div>
                <h3>CÁMARAS ACTIVAS:</h3>
                {% for camara in camaras %}
                    <div class="border p-3 mb-3 rounded">
                        <p>Identificador: {{ camara.id }}</p>
                        <p>Nombre de la cámara: {{ camara.ubicacion }}</p>
                        <p>Página de la cámara: <a href="{% url 'camara' id=camara.id %}">{{ camara.ubicacion }}</a></p>
                        <p>Página dinámica: <a href="{% url 'camaradyn' id=camara.id %}">{{ camara.ubicacion }}</a></p>
                        <p>Número de comentarios: {{ camara.comentario_set.count }} </p>
                        <p>Cámara formato JSON: <a href="{% url 'json' id=camara.id %}">Ver JSON</a></p>
                    </div>
                {% endfor %}
            </div>
        {% else %}
            <p>Pulse descargar para continuar.</p>
        {% endif %}
    </div>
</div>
{% endblock %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/comentario.html
{% extends "teveoapp/base.html" %}

{% block contenido %}
<div class="row">
    <div>
        <h3>PÁGINA PARA COMENTAR:</h3>
        <!-- Agregar un mensaje que indique quién está realizando el comentario -->
        <p>Comentar como: <strong>{{ usuario.nombre }}</strong></p>
        <div class="comment-info">
            <p><strong>ID:</strong> {{ camara.id }}</p>
            <p><strong>Camara:</strong> {{ camara.ubicacion }}</p>
            <p><strong>Fecha:</strong> {{ fecha }}</p>
        </div>
        <div class="comment-image">
            <img src="{{ camara.fuente }}" alt="Imagen de la cámara">
        </div>
        <form method="POST" action="{% if camara %}{% url 'comentario' camara.id %}{% endif %}">
            {% csrf_token %}
            <div>
                <p></p>
                <input type="text" class="form-control" id="texto" name="texto" placeholder="Escriba su comentario y pulse 'Enviar'" required>
            </div>
            <button type="submit" class="btn btn-primary">Enviar</button>
        </form>
    </div>
</div>
{% endblock %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/comentariosdyn.html
{% for coment in comentarios %}
    <li class="comment">
        <div class="comment-box">
            <div class="comment-info">
                <p><strong>Cámara:</strong> {{ coment.camara.id }}</p>
                <p><strong>Autor:</strong> {{ coment.autor_nombre }}</p>
                <p><strong>Fecha:</strong> {{ coment.fecha }}</p>
                <p><strong>Comentario:</strong></p>
                <div class="comment-text">
                    {{ coment.texto }}
                </div>
            </div>
            {% if coment.imagen %}
                <div class="comment-image">
                    <img src="data:image/jpeg;base64,{{ coment.imagen }}" alt="Imagen de comentario">
                </div>
            {% endif %}
        </div>
    </li>
{% endfor %}

teveoapp/teveoproject/teveoapp/templates/teveoapp/configuracion.html
{% extends "teveoapp/base.html" %}
{% load static %}

{% block contenido %}
<div class="row">
    <div class="col-md-12">
        <h2>CONFIGURACIÓN DE LA PÁGINA</h2>
        <form method="POST">
            {% csrf_token %}
            <div>
                <label for="nombre">Nombre del visitante:</label>
                <input type="text" class="form-control" id="nombre" name="nombre" value="{{ usuario.nombre }}">
            </div>
            <div>
                <label for="formato">Formato de letra:</label>
                <select class="form-control" id="formato" name="formato">
                    {% for opcion in opciones_formato %}
                    <option value="{{ opcion }}" {% if opcion == usuario.formato %}selected{% endif %}>{{ opcion }}</option>
                    {% endfor %}
                </select>
            </div>
            <div>
                <label for="tipo">Tamaño de letra:</label>
                <select class="form-control" id="tipo" name="tipo">
                    {% for opcion in opciones_tipo %}
                    <option value="{{ opcion }}" {% if opcion == usuario.tipo %}selected{% endif %}>{{ opcion }}</option>
                    {% endfor %}
                </select>
            </div>
            <button type="submit" class="btn btn-primary">Guardar configuración</button>
            <input type="hidden" name="authorize_link" value="1">
        </form>

        <!-- Funcionalidad de autorización -->
        {% if authorize_url %}
        <div class="mt-4">
            <p><strong>URL de Autorización:</strong> <a href="{{ authorize_url }}">{{ authorize_url }}</a></p>
        </div>
        {% endif %}

        <!-- Botón de terminar sesión -->
        <div class="mt-4">
            <h4>Para Terminar la Sesión:</h4>
            <a href="{% url 'salir' %}" class="btn btn-danger">Terminar Sesión</a>
        </div>
    </div>
</div>
{% endblock %}